#include "game\all_definitions.h"

extern struct s_container g_containers[CONTAINER_LAST_CONTAINER];

container_iterator container_find(container_id container, object_id to_find)
{
	container_iterator i;
	for (i=0;i<MAX_ITEMS_IN_CONTAINER;++i)
	{
		if (g_containers[container].objects[i]==to_find)
			return i;
	}
	return CONTAINER_ITERATOR_NPOS;
}

object_id  container_get(container_id conatainer, container_iterator obj_number)
{
	return g_containers[conatainer].objects[obj_number];
}

object_id  container_remove(container_id conatainer, container_iterator to_remove)
{
	object_id result = g_containers[conatainer].objects[to_remove];
	g_containers[conatainer].objects[to_remove]=OBJECT_NONE;
	return result;
}

container_iterator container_insert(container_id conatainer, object_id to_add)
{
	container_iterator i;
	for (i=0;i<MAX_ITEMS_IN_CONTAINER;++i)
	{
		if (g_containers[conatainer].objects[i]==OBJECT_NONE)
		{
			g_containers[conatainer].objects[i]=to_add;
			return i;
		}
	}
	return CONTAINER_ITERATOR_NPOS;
}

byte container_get_number_of_items(container_id conatainer)
{
	container_iterator i;
	byte result=0;
	for (i=0;i<MAX_ITEMS_IN_CONTAINER;++i)
	{
		if (g_containers[conatainer].objects[i]!=OBJECT_NONE)
			++result;
	}
	return result;
}

object_id container_object_move_with_choose(container_id source, container_id destination)
{
	object_id to_move=ui_container_choose_item(source);
	if (to_move!=OBJECT_NONE)
	{
		if (container_insert(destination,to_move)!=CONTAINER_ITERATOR_NPOS)
		{
			container_remove(source,container_find(source,to_move));
			return to_move;
		}
	}
	return OBJECT_NONE;
}

object_id container_merge(container_id container, object_id to_remove1, object_id to_remove2, object_id new_object)
{
	container_iterator r1, r2;

	r1=container_find(container,to_remove1);
	r2=container_find(container,to_remove2);

	if (r1==CONTAINER_ITERATOR_NPOS || r2==CONTAINER_ITERATOR_NPOS)
		return OBJECT_NONE;

	container_remove(container,r1);
	container_remove(container,r2);
	container_insert(container,new_object);
	return new_object;
}

