#ifndef CONTAINER_DEF_H
#define CONTAINER_DEF_H

#include "engine\basictypes.h"
#include "engine\object.h"

#define CONTAINER_NONE 0xFF
#define CONTAINER_ITERATOR_NPOS 0xFF

typedef byte container_id; // if you want to have more than 255 containers, then change this type to word
typedef byte container_iterator; // item index iterator in container

struct s_container {
	char *name;
	object_id objects[MAX_OBJECTS_INSIDE_CONTAINER];
};

//////////////////////////////////////////////////////////////////////////
// Container API
//////////////////////////////////////////////////////////////////////////

container_iterator container_find(container_id conatainer, object_id to_find);
object_id container_get(container_id conatainer, container_iterator obj_number);
object_id container_remove(container_id conatainer, container_iterator to_remove);
container_iterator container_insert(container_id conatainer, object_id to_add);
byte container_get_number_of_items(container_id conatainer);

object_id container_object_move_with_choose(container_id source, container_id destination);

// helper function, because it's typical action in adventure games
object_id container_merge(container_id container, object_id to_remove1, object_id to_remove2, object_id new_object);

#endif