#include "game\all_definitions.h"
#include <string.h>

// In this object oriented approach you should never have following line declared anywhere else
extern struct s_object g_objects[OBJECT_LAST_OBJECT];

object_id object_get_through_references(object_id obj)
{
	for(;;)
	{
		if (obj==OBJECT_NONE)
			break;

		if (g_objects[obj].name==TEXT_NONE)
			obj=g_objects[obj].variable;
		else // obj.name points to real object
			break;
	}
	return obj;
}


void object_action_replace(object_id obj,action_function old_function,action_function new_function,char *new_name)
{
	byte i;
	for (i=0;i<MAX_OBJECT_ACTIONS;++i)
	{
		if (g_objects[obj].actions[i].action==old_function)
		{
			g_objects[obj].actions[i].name=new_name;
			g_objects[obj].actions[i].action=new_function;
			break;
		}
	}
}


// The 0x80 bit in AREA objects determines if it's active or not
// You have 7 bits to store other data in area object variable

// Functions to access data stored in objects
// Use always them instead of direct access, because they:
// 1. encode/decode bits for area/objects
// not implemented: 2. pass over object references
byte object_value_get(object_id obj)
{
	return (g_objects[obj].variable&VALUE_MASK);
}

void object_value_set(object_id obj, byte value)
{
	g_objects[obj].variable=(g_objects[obj].variable&ACTIVITY_MASK)|(value&VALUE_MASK);
}

bool object_flags_check(object_id obj,  byte flags)
{
	return ((g_objects[obj].variable&flags)==flags);
}

void object_flags_set(object_id obj,  byte flags)
{
	g_objects[obj].variable|=flags;
}

void object_flags_zero(object_id obj,  byte flags)
{
	g_objects[obj].variable=(g_objects[obj].variable&(~flags | ACTIVITY_MASK));
}

char *object_name_get(object_id obj)
{
	return g_objects[obj].name;
}

void object_name_set(object_id obj, char *name)
{
	g_objects[obj].name = name;
}

bool area_activity_check(object_id ar)
{
	if ((g_objects[ar].variable&ACTIVITY_MASK)==AREA_ACTIVE)
		return true;
	return false;
}


void area_activity_on(object_id ar)
{
	g_objects[ar].variable=(g_objects[ar].variable&VALUE_MASK);
}

void area_activity_off(object_id ar)
{
	g_objects[ar].variable|=AREA_INACTIVE;
}

