#ifndef SYSTEM_H
#define SYSTEM_H

#include "engine\object.h"
#include "engine\container.h"
#include "engine\action.h"

#ifdef __ATARI__
#define debug_print(x)
#define random() (*((unsigned char *)0xd20a))
#else
#define debug_print(x) printf("%s\n",x)
#define random() rand()
#endif

// System dependent function
void system_init(void);

// User interface functions
object_id ui_container_choose_item(container_id container);

// Choose object by screen area or from inventory with joystick, mouse or keyboard commands if text-mode game
object_id ui_object_choose(room_id room);

action_function ui_action_choose(object_id obj);
#endif
